from Products.CMFCore.utils import getToolByName
from Products.Samplex.config import TEAMSPACES_FOLDER_DATA

teams_map = {'t1':{'title':'Team 1',
                   'department':'Dept of Running'},
             't2':{'title':'Team 2',
                   'department':'Dept of Running'},
             't3':{'title':'Team 3',
                   'department':'Dept of Hiding'},
             }

members_map = {'m1':{'firstname':'Member',
                     'lastname': 'One',
                     'password':'testy',
                     'email':'notreal@xyxyxyxy.com',
                     'teams': ['t1', 't2']},
               'm2':{'firstname':'Member',
                     'lastname':'Two',
                     'password':'testy',
                     'email':'notreal@xyxyxyxy.com',
                     'teams': ['t2', 't3']},
               'm3':{'firstname':'Member',
                     'lastname':'Three',
                     'password':'testy',
                     'email':'notreal@xyxyxyxy.com',
                     'teams': ['t3', 't1']},
               }

def create_test_content(self):
    """ populates a samplex site w/ some dummy test content """
    portal = getToolByName(self, 'portal_url').getPortalObject()
    mdc = getToolByName(self, 'portal_memberdata')
    tm_tool = getToolByName(self, 'portal_teams')
    wf_tool = getToolByName(self, 'portal_workflow')
    
    ts_folder_id = TEAMSPACES_FOLDER_DATA['id']
    tcontainer = getattr(portal, ts_folder_id, None)
    if tcontainer is None:
        return "ERROR: no '%s' folder" % ts_folder_id

    out = []
    for tm_id, tm_data in teams_map.items():
        tm_tool.invokeFactory('SamplexTeam', tm_id)
        tm = tm_tool.getTeamById(tm_id)
        tm.update(**tm_data) # doing this in invokeFactory failed... why?
        out.append('SamplexTeam %s added' % tm_id)
        tcontainer.invokeFactory('TeamSpace', tm_id, space_teams=(tm,),
                                 **tm_data)
        out.append('TeamSpace %s added' % tm_id)

    for mem_id, mem_data in members_map.items():
        mdc.invokeFactory('SamplexMember', mem_id, **mem_data)
        out.append('Member %s added' % mem_id)
        for tm_id in mem_data['teams']:
            team = tm_tool.getTeamById(tm_id)
            team.addMember(mem_id)
            out.append('-> added to team %s' % tm_id)
            mship = team.getMembershipByMemberId(mem_id)
            wf_tool.doActionFor(mship, 'activate')
            out.append('-> activated for team %s' % tm_id)

    return "\n".join(out)
