##############################################################################
# Copyright (c) 2005 Rob Miller (and contributors)
# All Rights Reserved.
#
# This software is subject to the provisions of the GNU General Public
# License, Version 2.0 (GPL).  A copy of the GPL should accompany this
# distribution.  THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL
# EXPRESS OR IMPLIED WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF TITLE, MERCHANTABILITY,
# AGAINST INFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE.
##############################################################################


"""
Product bootstrapping and initialization.

$Id:$
"""

from Products.CMFCore import utils, DirectoryView
from Products.Archetypes import public as atapi
from config import PROJECT_NAME, GLOBALS

from permissions import initialize as initialize_permissions

DirectoryView.registerDirectory('skins', GLOBALS)

import content
import policies

def initialize(context):
    policies.register(context, GLOBALS)

    content_types, constructors, ftis = atapi.process_types(
        atapi.listTypes(PROJECT_NAME),
        PROJECT_NAME)

    permissions = initialize_permissions()
    allTypes = zip(content_types, constructors)
    for atype, constructor in allTypes:
        kind = "%s: %s" % (PROJECT_NAME, atype.archetype_name)
        utils.ContentInit(
            kind,
            content_types      = (atype,),
            permission         = permissions[atype.portal_type],
            extra_constructors = (constructor,),
            fti                = ftis,
            ).initialize(context)
