##############################################################################
# Copyright (c) 2005 Rob Miller (and contributors)
# All Rights Reserved.
#
# This software is subject to the provisions of the GNU General Public License,
# Version 2.0 (GPL).  A copy of the GPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
##############################################################################

"""
Custom team class

$Id:$
"""

from Products.CMFCore.utils import getToolByName

from Products.Archetypes.public import *
from Products.TeamSpace.team import Team, team_type_information
from AccessControl import ClassSecurityInfo

added_team_schema = Schema((
    StringField(
        'department',
        widget=StringWidget(
            label="Department",
            label_msgid="label_department",
            description_msgid="desc_department",
            description="Organizational department to which this team belongs.",
            ),
        ),
        
    ))

samplexteam_type_info = team_type_information.copy()
samplexteam_type_info.update(
    {'title': 'SamplexTeam',
     'id': 'SamplexTeam',
     'portal_type': 'SamplexTeam',
     'meta_type': 'SamplexTeam',
     'product': 'Samplex',
     'factory': 'addSamplexTeam'}
    )
factory_type_information = (samplexteam_type_info, )

class SamplexTeam(Team):
    """ The Samplex Teamspace """
    
    meta_type = portal_type = 'SamplexTeam'
    archetype_name = 'Samplex Team'

    schema = Team.schema + added_team_schema


registerType(SamplexTeam)
