##############################################################################
# Copyright (c) 2005 Rob Miller
# All Rights Reserved.
#
# This software is subject to the provisions of the GNU General Public
# License, Version 2.0 (GPL).  A copy of the GPL should accompany this
# distribution.  THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL
# EXPRESS OR IMPLIED WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF TITLE, MERCHANTABILITY,
# AGAINST INFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE.
##############################################################################

"""
Product permissions definition and initialization.

$Id:$
"""
from Products.CMFCore import permissions as cmfcore_permissions
from Products.Archetypes import public as atapi
from Products.CMFMember.permission import ADD_MEMBER_PERMISSION
import config

predefined_perm_map = {'SamplexMember': ADD_MEMBER_PERMISSION}

# all of the "team roles" are given each of the "team permissions" by default
DEFAULT_PERMISSIONS_DATA = (
    (['Manager', 'Owner', 'TeamMember', 'TeamReviewer', 'Reviewer'],
     ['Add portal content', 'Add portal folders', 'Delete objects',
      'Copy or Move', 'Add Documents, Images, and Files',
      'ATContentTypes: Add Document', 'ATContentTypes: Add Event',
      'ATContentTypes: Add Favorite', 'ATContentTypes: Add File',
      'ATContentTypes: Add Folder', 'ATContentTypes: Add Image',
      'ATContentTypes: Add Large Plone Folder', 'ATContentTypes: Add Link']),
    (['Manager', 'Owner', 'TeamReviewer', 'Reviewer'],
     ['TeamSpace: Manage team memberships', 'TeamSpace: Manage team']),
    )

def initialize():
    permissions = {}
    types = atapi.listTypes(config.PROJECT_NAME)
    for atype in types:
        portal_type = atype['portal_type']
        permission = predefined_perm_map.get(portal_type, None)
        if permission is None:
            # construct a permission on the fly
            permission = "%s: Add %s" % (config.PROJECT_NAME,
                                         portal_type)
            cmfcore_permissions.setDefaultRoles(permission, ('Manager',))
        permissions[portal_type] = permission

    return permissions
