##############################################################################
# Copyright (c) 2005 Rob Miller (and contributors)
# All Rights Reserved.
#
# This software is subject to the provisions of the GNU General Public
# License, Version 2.0 (GPL).  A copy of the GPL should accompany this
# distribution.  THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL
# EXPRESS OR IMPLIED WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF TITLE, MERCHANTABILITY,
# AGAINST INFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE.
##############################################################################

"""
Define and register customization policy

$Id:$
"""

from Products.CMFPlone.Portal import addPolicy
from Products.CMFPlone.interfaces.CustomizationPolicy import ICustomizationPolicy
from Products.CMFPlone.CustomizationPolicy import DefaultCustomizationPolicy
from Products.CMFCore.utils import getToolByName

from Products.Samplex.config import DEPENDENCIES, PROJECT_NAME

class SamplexPolicy(DefaultCustomizationPolicy):

    __implements__=ICustomizationPolicy

    availableAtConstruction = True

    def customize(self, portal):
        DefaultCustomizationPolicy().customize(portal)
        qi = getToolByName(portal, 'portal_quickinstaller')
        for product in DEPENDENCIES + [PROJECT_NAME]:
            if not qi.isProductInstalled(product):
                qi.installProduct(product)


def register(context, app_state):
    addPolicy('Samplex Site', SamplexPolicy())
