##############################################################################
# Copyright (c) 2005 Rob Miller (and contributors)
# All Rights Reserved.
#
# This software is subject to the provisions of the GNU General Public
# License, Version 2.0 (GPL).  A copy of the GPL should accompany this
# distribution.  THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL
# EXPRESS OR IMPLIED WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF TITLE, MERCHANTABILITY,
# AGAINST INFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE.
##############################################################################

"""
Custom member class

$Id:$
"""

from Testing import ZopeTestCase
from Products.PloneTestCase import ptc, setup

from Products.CMFCore.utils import getToolByName

from Products.Samplex.config import Z_DEPENDENCIES, DEPENDENCIES, PROJECT_NAME

for x in Z_DEPENDENCIES + DEPENDENCIES + [PROJECT_NAME]:
    ZopeTestCase.installProduct(x)

class SamplexTestCase(ptc.PloneTestCase):
    """ Samplex product test case base class """

    def installProducts(self, products):
        qi = getToolByName(self.portal, 'portal_quickinstaller')
        for product in products:
            if not qi.isProductInstalled(product):
                if qi.isProductInstallable(product):
                    qi.installProduct(product)
                else:
                    raise "Product %s not installable" % product

    def afterSetUp(self):
        self.installProducts([PROJECT_NAME])

setup.setupPloneSite(policy="CMFMember Site")
