##############################################################################
# Copyright (c) 2005 Rob Miller (and contributors)
# All Rights Reserved.
#
# This software is subject to the provisions of the GNU General Public
# License, Version 2.0 (GPL).  A copy of the GPL should accompany this
# distribution.  THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL
# EXPRESS OR IMPLIED WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF TITLE, MERCHANTABILITY,
# AGAINST INFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE.
##############################################################################

"""
Test the basic installation of the Samplex components

$Id:$
"""

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Products.CMFCore.utils import getToolByName

from Products.Samplex.Extensions.create_test_content import members_map, \
     create_test_content
from base import SamplexTestCase

class TestMember(SamplexTestCase):
    """ tests the behaviour of the SamplexMember custom member class """

    def afterSetUp(self):
        SamplexTestCase.afterSetUp(self)
        self.ms_tool = getToolByName(self.portal, 'portal_membership')
        self.mdc = getToolByName(self.portal, 'portal_memberdata')

    def testActiveTeamsField(self):
        self.loginAsPortalOwner()
        create_test_content(self.portal)
        m1 = self.ms_tool.getMemberById('m1')
        
        m1_correct_tms = members_map['m1']['teams']
        m1_correct_tms.sort()
        m1_tms = m1.getField('active_teams').getAccessor(m1)()
        m1_tms.sort()
        self.failUnless(m1_tms == m1_correct_tms)

    def testFullNameField(self):
        mem_id = 'm1'
        mem_data = members_map[mem_id]
        self.mdc.invokeFactory('SamplexMember', mem_id, **mem_data)
        mem = self.ms_tool.getMemberById(mem_id)
        correct_fullname = "%s %s" % (mem_data['firstname'],
                                      mem_data['lastname'])
        fullname = mem.getField('fullname').getAccessor(mem)()
        self.failUnless(fullname == correct_fullname)

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestMember))
    return suite

if __name__ == '__main__':
    framework()
