# 
#
# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: folder_samplex_workflow/Samplex Folder Workflow
# Date: 2005/07/09 15:15:15.886 GMT-7
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# No script detected in this workflow
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 1.1.1.1 $"[11:-2]

from Products.CMFCore.WorkflowTool import addWorkflowFactory

from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition

def setupFolder_samplex_workflow(wf):
    "..."
    wf.setProperties(title='Samplex Folder Workflow')

    for s in ['team_visible', 'visible', 'team_visible_locked', 'visible_locked', 'private']:
        wf.states.addState(s)
    for t in ['unlockAsTeamVisible', 'hide', 'show', 'lockAsVisible', 'lockAsTeamVisible', 'team', 'unlockAsVisible']:
        wf.transitions.addTransition(t)
    for v in ['action', 'time', 'comments', 'actor', 'review_history']:
        wf.variables.addVariable(v)
    for l in []:
        wf.worklists.addWorklist(l)
    for p in ('Access contents information', 'Modify portal content', 'View', 'List folder contents', 'Delete objects'):
        wf.addManagedPermission(p)
        

    ## Initial State
    wf.states.setInitialState('visible')

    ## States initialization
    sdef = wf.states['team_visible']
    sdef.setProperties(title="""Team Visible""",
                       transitions=('hide', 'lockAsTeamVisible', 'show'))
    sdef.setPermission('Access contents information', 0, ['Manager', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('Modify portal content', 0, ['Manager', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('View', 0, ['Manager', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('List folder contents', 0, ['Manager', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('Delete objects', 0, ['Manager', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])

    sdef = wf.states['visible']
    sdef.setProperties(title="""Visible but not published""",
                       transitions=('hide', 'lockAsVisible', 'team'))
    sdef.setPermission('Access contents information', 1, ['Manager', 'Member', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('Modify portal content', 0, ['Manager', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('View', 1, ['Manager', 'Member', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('List folder contents', 0, ['Manager', 'Member', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('Delete objects', 0, ['Manager', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])

    sdef = wf.states['team_visible_locked']
    sdef.setProperties(title="""Team Visible Locked""",
                       transitions=('unlockAsTeamVisible',))
    sdef.setPermission('Access contents information', 0, ['Manager', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('Modify portal content', 0, ['Manager', 'Owner'])
    sdef.setPermission('View', 0, ['Manager', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('List folder contents', 0, ['Manager', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('Delete objects', 0, ['Manager', 'Owner'])

    sdef = wf.states['visible_locked']
    sdef.setProperties(title="""Visible Locked""",
                       transitions=('unlockAsVisible',))
    sdef.setPermission('Access contents information', 1, ['Manager', 'Member', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('Modify portal content', 0, ['Manager', 'Owner'])
    sdef.setPermission('View', 1, ['Manager', 'Member', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('List folder contents', 0, ['Manager', 'Member', 'Owner', 'Reviewer', 'TeamMember', 'TeamReviewer'])
    sdef.setPermission('Delete objects', 0, ['Manager', 'Owner'])

    sdef = wf.states['private']
    sdef.setProperties(title="""Visible and editable only by owner""",
                       transitions=('show', 'team'))
    sdef.setPermission('Access contents information', 0, ['Manager', 'Owner', 'Reviewer', 'TeamReviewer'])
    sdef.setPermission('Modify portal content', 0, ['Manager', 'Owner', 'Reviewer', 'TeamReviewer'])
    sdef.setPermission('View', 0, ['Manager', 'Owner', 'Reviewer', 'TeamReviewer'])
    sdef.setPermission('List folder contents', 0, ['Manager', 'Owner', 'Reviewer', 'TeamReviewer'])
    sdef.setPermission('Delete objects', 0, ['Manager', 'Owner', 'Reviewer', 'TeamReviewer'])


    ## Transitions initialization
    tdef = wf.transitions['unlockAsTeamVisible']
    tdef.setProperties(title="""Unlock as Team Visible""",
                       new_state_id="""team_visible""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Unlock""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Owner; Manager; Reviewer; TeamReviewer'},
                       )

    tdef = wf.transitions['hide']
    tdef.setProperties(title="""Member makes content private""",
                       new_state_id="""private""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Make private""",
                       actbox_url="""%(content_url)s/content_hide_form""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Owner'},
                       )

    tdef = wf.transitions['show']
    tdef.setProperties(title="""Member makes content visible""",
                       new_state_id="""visible""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Make visible""",
                       actbox_url="""%(content_url)s/content_show_form""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Owner'},
                       )

    tdef = wf.transitions['lockAsVisible']
    tdef.setProperties(title="""Lock as Visible""",
                       new_state_id="""visible_locked""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Lock""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Owner; Manager; Reviewer; TeamReviewer'},
                       )

    tdef = wf.transitions['lockAsTeamVisible']
    tdef.setProperties(title="""Lock as Team Visible""",
                       new_state_id="""team_visible_locked""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Lock""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Owner; Manager; Reviewer; TeamReviewer'},
                       )

    tdef = wf.transitions['team']
    tdef.setProperties(title="""Member makes content team visible""",
                       new_state_id="""team_visible""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Make team visible""",
                       actbox_url="""%(content_url)s/what_is_this_for""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Modify portal content'},
                       )

    tdef = wf.transitions['unlockAsVisible']
    tdef.setProperties(title="""Unlock as Visible""",
                       new_state_id="""visible""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Unlock""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Owner; Manager; Reviewer; TeamReviewer'},
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    ## Worklists Initialization

def createFolder_samplex_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupFolder_samplex_workflow(ob)
    return ob

addWorkflowFactory(createFolder_samplex_workflow,
                   id='folder_samplex_workflow',
                   title='Samplex Folder Workflow')

    